<template>
    <div class="row">
        <div class="col-6">
            <label for="solicitante" class="form-label">Solicitante:</label>
            <auto-complete v-model="data.solicitante" :elements="usuarioStore.listadoSolicitantes" placeholder="Solicitante"
                :minLength="3" :disabled="false" />
        </div>
        <div class="col-4 mt-3">
            <button alt="Guardar" title="Guardar" type="button" class="btn btn-guardar mx-2 fs-3" @click="guardar()">
            <i class="fa-solid fa-floppy-disk "></i>
        </button>
        </div>
    </div>
</template>

<script setup lang="ts">
//libreries
import { reactive } from "vue";
import { useRoute, useRouter } from "vue-router";
import { AutoComplete } from "@hcd-bsas/vue3-components";
import http from "@/http";
import { loading, urlApi } from "@/shared.js";
import Swal from "sweetalert2/dist/sweetalert2.js";
import { AxiosError } from "axios";
//entities
import type Solicitante from "@/entities/Solicitante";
//store
import { useUsuariosStore } from "@/stores/usuarios";

const emit = defineEmits(["closeModal"]);
const router = useRouter();
const route = useRoute();

const usuarioStore = useUsuariosStore();

const data = reactive({
    solicitante: null as Solicitante | null,
    lista: [] as Number[],
});


async function guardar() {
    loading.show();
    data.lista[0] = data.solicitante!.id_tabla_sol
    try {
        var rta = await http.post(urlApi + "addUsuarioSolicitante", {
            id_usuario_perfil: route.params.id,
            //id_tabla_sol: data.solicitante!.id_tabla_sol,
            id_tabla_sol: data.lista,

        });
        if (rta.data.status == "success") {
            await usuarioStore.updateListadoUsuariosSolicitantes({
                id_usuario_perfil: route.params.id,
            });
            data.solicitante = null;
            emit("closeModal");
            loading.hide();
            Swal.fire({
                icon: "success",
                text: "Se grabo el Solicitante.",
            });
        } else {
            Swal.fire({
                icon: "error",
                text: rta.data.message,
            });
            loading.hide();
        }
    } catch (error: any) {
        var mensaje: string = error.message;
        console.log("ERROR");
        if (error instanceof AxiosError) {
            mensaje = error.response?.data.res.mensaje;
        }
        Swal.fire({
            icon: "error",
            text: mensaje,
        });
        loading.hide();
    }
}
</script>
  
  <!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>